diff -ruN ../nakedmudv3.2.1/src/scripts/pyaccount.c src/scripts/pyaccount.c
--- ../nakedmudv3.2.1/src/scripts/pyaccount.c	1969-12-31 19:00:00.000000000 -0500
+++ src/scripts/pyaccount.c	2006-12-24 22:15:56.000000000 -0500
@@ -0,0 +1,332 @@
+//*****************************************************************************
+//
+// pyaccount.c
+//
+// Contains a python account module, and an Account class that is a python 
+// wrapper for NakedMud accounts.
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../account.h"
+#include "../character.h"
+#include "../save.h"
+
+#include "scripts.h"
+#include "pyplugs.h"
+#include "pyauxiliary.h"
+#include "pyaccount.h"
+#include "pychar.h"
+
+
+
+//*****************************************************************************
+// local structures and defines
+//*****************************************************************************
+
+// a list of the get/setters on the Exit class
+LIST *pyaccount_getsetters = NULL;
+
+// a list of the methods on the Exit class
+LIST *pyaccount_methods = NULL;
+
+typedef struct {
+  PyObject_HEAD
+  ACCOUNT_DATA *account;
+} PyAccount;
+
+
+
+//*****************************************************************************
+// allocation, deallocation, initialization, and comparison
+//*****************************************************************************
+void PyAccount_dealloc(PyAccount *self) {
+  if(account_exists(accountGetName(self->account)))
+    unreference_account(self->account);
+  self->ob_type->tp_free((PyObject*)self);
+}
+
+PyObject *PyAccount_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
+    PyAccount *self;
+    self = (PyAccount *)type->tp_alloc(type, 0);
+    self->account = NULL;
+    return (PyObject *)self;
+}
+
+int PyAccount_init(PyAccount *self, PyObject *args, PyObject *kwds) {
+  char *kwlist[] = {"name", NULL};
+  char     *name = NULL;
+
+  // get the uid
+  if (!PyArg_ParseTupleAndKeywords(args, kwds, "s", kwlist, &name)) {
+    PyErr_Format(PyExc_TypeError, "Accounts may only be created using a name");
+    return -1;
+  }
+
+  // make sure an account with this name exists
+  if(!account_exists(name)) {
+    PyErr_Format(PyExc_TypeError, "Account with name %s does not exist.", name);
+    return -1;
+  }
+
+  self->account = get_account(name);
+  return 0;
+}
+
+int PyAccount_compare(PyAccount *acc1, PyAccount *acc2) {
+  return strcasecmp(accountGetName(acc1->account),
+		    accountGetName(acc2->account));
+}
+
+
+
+//*****************************************************************************
+// getters and setters for the Account class
+//*****************************************************************************
+PyObject *PyAccount_getname(PyAccount *self, void *closure) {
+  ACCOUNT_DATA *acc = PyAccount_AsAccount((PyObject *)self);
+  if(acc != NULL) return Py_BuildValue("s", accountGetName(acc));
+  else            return NULL;
+}
+
+
+
+//*****************************************************************************
+// methods for the Account class
+//*****************************************************************************
+PyObject *PyAccount_add_char(PyAccount *self, PyObject *args) {
+  PyObject    *val = NULL;
+  CHAR_DATA    *ch = NULL;
+  const char *name = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &val)) {
+    PyErr_Format(PyExc_TypeError,
+		 "add_char() must be supplied with a character or name.");
+    return NULL;
+  }
+
+  // make sure we exist
+  ACCOUNT_DATA *acc = PyAccount_AsAccount((PyObject *)self);
+  if(acc == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to add character to a nonexistant account.");
+    return NULL;
+  }
+
+  if(PyString_Check(val))
+    name = PyString_AsString(val);
+  else if(PyChar_Check(val)) {
+    ch = PyChar_AsChar(val);
+    if(ch != NULL)
+      name = charGetName(ch);
+    else {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to add nonexistant character %d to account.",
+		   PyChar_AsUid(val));
+      return NULL;
+    }
+  }
+
+  accountPutChar(acc, name);
+  listSortWith(accountGetChars(acc), strcasecmp);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *PyAccount_characters(PyAccount *self, PyObject *args) {
+  ACCOUNT_DATA *acc = PyAccount_AsAccount((PyObject *)self);
+  if(acc == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to add character to a nonexistant account.");
+    return NULL;
+  }
+
+  LIST_ITERATOR *name_i = newListIterator(accountGetChars(acc));
+  PyObject        *list = PyList_New(0);
+  const char      *name = NULL;
+
+  ITERATE_LIST(name, name_i) {
+    PyObject *val = PyString_FromString(name);
+    PyList_Append(list, val);
+    Py_DECREF(val);
+  } deleteListIterator(name_i);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
+}
+
+//
+// returns the specified piece of auxiliary data from the account
+// if it is a piece of python auxiliary data.
+PyObject *PyAccount_get_auxiliary(PyAccount *self, PyObject *args) {
+  char *keyword = NULL;
+  if(!PyArg_ParseTuple(args, "s", &keyword)) {
+    PyErr_Format(PyExc_TypeError,
+		 "getAuxiliary() must be supplied with the name that the "
+		 "auxiliary data was installed under!");
+    return NULL;
+  }
+
+  // make sure we exist
+  ACCOUNT_DATA *acc = PyAccount_AsAccount((PyObject *)self);
+  if(acc == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to get auxiliary data for a nonexistant account.");
+    return NULL;
+  }
+
+  // make sure the auxiliary data exists
+  if(!pyAuxiliaryDataExists(keyword)) {
+    PyErr_Format(PyExc_StandardError,
+		 "No auxiliary data named '%s' exists!", keyword);
+    return NULL;
+  }
+
+  PyObject *data = accountGetAuxiliaryData(acc, keyword);
+  if(data == NULL)
+    data = Py_None;
+  PyObject *retval = Py_BuildValue("O", data);
+  //  Py_DECREF(data);
+  return retval;
+}
+
+
+
+//*****************************************************************************
+// structures to define our methods and classes
+//*****************************************************************************
+PyTypeObject PyAccount_Type = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "account.Account",         /*tp_name*/
+    sizeof(PyAccount),         /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)PyAccount_dealloc,/*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    (cmpfunc)PyAccount_compare,/*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "Python Account object",   /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    0,                         /* tp_methods */
+    0,                         /* tp_members */
+    0,                         /* tp_getset */ 
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)PyAccount_init,  /* tp_init */
+    0,                         /* tp_alloc */
+    PyAccount_new,             /* tp_new */
+};
+
+PyMethodDef account_module_methods[] = {
+  {NULL, NULL, 0, NULL}  /* Sentinel */
+};
+
+
+
+//*****************************************************************************
+// implementation of pyexit.h
+//*****************************************************************************
+void PyAccount_addGetSetter(const char *name, void *g, void *s,const char *doc){
+  // make sure our list of get/setters is created
+  if(pyaccount_getsetters == NULL) pyaccount_getsetters = newList();
+
+  // make the GetSetter def
+  PyGetSetDef *def = calloc(1, sizeof(PyGetSetDef));
+  def->name        = strdup(name);
+  def->get         = (getter)g;
+  def->set         = (setter)s;
+  def->doc         = (doc ? strdup(doc) : NULL);
+  def->closure     = NULL;
+  listPut(pyaccount_getsetters, def);
+}
+
+void PyAccount_addMethod(const char *name, void *f, int flags, const char *doc){
+  // make sure our list of methods is created
+  if(pyaccount_methods == NULL) pyaccount_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyaccount_methods, def);
+}
+
+// initialize accounts for use. This must be called AFTER 
+PyMODINIT_FUNC
+init_PyAccount(void) {
+    PyObject* module = NULL;
+
+    // add all of the basic getsetters
+    PyAccount_addGetSetter("name", PyAccount_getname, NULL, 
+			   "the account's name.");
+
+    // add all of the basic methods
+    PyAccount_addMethod("add_char", PyAccount_add_char, METH_VARARGS,
+			"adds a character to the account.");
+    PyAccount_addMethod("characters", PyAccount_characters, METH_VARARGS,
+			"lists names of all characters tied to the account.");
+    PyAccount_addMethod("getAuxiliary", PyAccount_get_auxiliary, METH_VARARGS,
+			"gets the account auxiliary data with given key.");
+
+    // add in all the getsetters and methods
+    makePyType(&PyAccount_Type, pyaccount_getsetters, pyaccount_methods);
+    deleteListWith(pyaccount_getsetters, free); pyaccount_getsetters = NULL;
+    deleteListWith(pyaccount_methods,    free); pyaccount_methods    = NULL;
+
+    // make sure the account class is ready to be made
+    if (PyType_Ready(&PyAccount_Type) < 0)
+        return;
+
+    // initialize the module
+    module = Py_InitModule3("account", account_module_methods,
+			    "The account module, for all MUD account-related "
+			    "stuff.");
+
+    // make sure the module parsed OK
+    if (module == NULL)
+      return;
+
+    // add the Account class to the account module
+    PyTypeObject *type = &PyAccount_Type;
+    PyModule_AddObject(module, "Account", (PyObject *)type);
+    Py_INCREF(&PyAccount_Type);
+}
+
+ACCOUNT_DATA *PyAccount_AsAccount(PyObject *account) {
+  return ((PyAccount *)account)->account;
+}
+
+int PyAccount_Check(PyObject *value) {
+  return PyObject_TypeCheck(value, &PyAccount_Type);
+}
+
+PyObject *newPyAccount(ACCOUNT_DATA *account) {
+  PyAccount *py_account = 
+    (PyAccount *)PyAccount_new(&PyAccount_Type, NULL, NULL);
+  py_account->account = account;
+  if(account_exists(accountGetName(account)))
+    reference_account(account);
+  return (PyObject *)py_account;
+}
diff -ruN ../nakedmudv3.2.1/src/scripts/pyaccount.h src/scripts/pyaccount.h
--- ../nakedmudv3.2.1/src/scripts/pyaccount.h	1969-12-31 19:00:00.000000000 -0500
+++ src/scripts/pyaccount.h	2006-12-24 22:15:56.000000000 -0500
@@ -0,0 +1,42 @@
+#ifndef PYACCOUNT_H
+#define PYACCOUNT_H
+//*****************************************************************************
+//
+// pyaccount.h
+//
+// Contains a python account module, and an Account class that is a python 
+// wrapper for NakedMud accounts. If you wish to give python access to more
+// features of an account, it should NOT be done by editing pyaccount.c! Use 
+// PyAccount_addGetSetter and PyAccount_addMethod in a new module implementing 
+// the feature you want to give Python access to.
+//
+//*****************************************************************************
+
+// initialize accounts for use. This must be called AFTER all other modules
+// have added in new get/setters and methods to pyroom
+PyMODINIT_FUNC     init_PyAccount(void);
+PyObject            *newPyAccount(ACCOUNT_DATA *account);
+ACCOUNT_DATA *PyAccount_AsAccount(PyObject *account);
+
+//
+// checks to see if the PyObject is a PyAccount
+int          PyAccount_Check(PyObject *value);
+
+//
+// getters allow Python to access pieces of the Account module. Setters allow
+// Python to change pieces of the account module. Getters are called when Python
+// tries to get the value of some variable on the object, and setters are called
+// when Python tries to set the value of some variable on the object. Get and
+// Set do not both need to be supplied. Examples of how to add new getters and
+// setters is presented in pyaccount.c
+void PyAccount_addGetSetter(const char *name, void *g, void *s, const char *doc);
+
+//
+// Adds a new method function (i.e. void *f) to the Account class. Name is the 
+// name of the function, f is the PyCFunction implementing the new method, 
+// flags is the type of method beings used (almost always METH_VARARGS), and
+// dog is an (optional) description of what the method does. For examples on
+// how to add new methods, see pyaccount.c
+void PyAccount_addMethod(const char *name, void *f, int flags, const char *doc);
+
+#endif // PYACCOUNT_H
diff -ruN ../nakedmudv3.2.1/src/scripts/pyauxiliary.c src/scripts/pyauxiliary.c
--- ../nakedmudv3.2.1/src/scripts/pyauxiliary.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyauxiliary.c	2006-12-24 22:15:56.000000000 -0500
@@ -131,6 +131,8 @@
     SET_BIT(type, AUXILIARY_TYPE_ROOM);
   if(is_keyword(installs_on, "object",    FALSE))
     SET_BIT(type, AUXILIARY_TYPE_OBJ);
+  if(is_keyword(installs_on, "account",   FALSE))
+    SET_BIT(type, AUXILIARY_TYPE_ACCOUNT);
   // more types to come soon!!
   //***********
   // FINISH ME
diff -ruN ../nakedmudv3.2.1/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.2.1/src/scripts/pychar.c	2006-07-10 22:15:16.000000000 -0400
+++ src/scripts/pychar.c	2006-12-24 22:15:56.000000000 -0500
@@ -30,6 +30,7 @@
 #include "pyroom.h"
 #include "pyobj.h"
 #include "pyexit.h"
+#include "pyaccount.h"
 #include "pyauxiliary.h"
 
 
@@ -172,8 +173,14 @@
 
 PyObject *PyChar_getroom(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
-  if(ch != NULL) return Py_BuildValue("O", roomGetPyFormBorrowed(charGetRoom(ch)));
-  else           return NULL;
+  if(ch == NULL)
+    return NULL;
+  else if(charGetRoom(ch) != NULL)
+    return Py_BuildValue("O", roomGetPyFormBorrowed(charGetRoom(ch)));
+  else {
+    Py_INCREF(Py_None);
+    return Py_BuildValue("O", Py_None);
+  }
 }
 
 PyObject *PyChar_getlastroom(PyChar *self, void *closure) {
@@ -184,7 +191,7 @@
     return Py_BuildValue("O", roomGetPyFormBorrowed(charGetLastRoom(ch)));
   else {
     Py_INCREF(Py_None);
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   }
 }
 
@@ -223,7 +230,7 @@
   if(ch == NULL) 
     return NULL;
   else if(charGetFurniture(ch) == NULL)
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   else 
     return Py_BuildValue("O", objGetPyFormBorrowed(charGetFurniture(ch)));
 }
@@ -291,7 +298,6 @@
   return list;
 }
 
-
 PyObject *PyChar_getusergroups(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch != NULL) 
@@ -300,6 +306,18 @@
     return NULL;
 }
 
+PyObject *PyChar_getsocket(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL)
+    return NULL;
+  else {
+    SOCKET_DATA *sock = charGetSocket(ch);
+    if(sock == NULL)
+      return Py_BuildValue("O", Py_None);
+    return Py_BuildValue("O", socketGetPyFormBorrowed(sock));
+  }
+}
+
 
 
 //
@@ -447,12 +465,8 @@
   }
 
   const char *race = PyString_AsString(value);
-  if(!isRace(race)) {
-    char buf[SMALL_BUFFER];
-    sprintf(buf, "%s is an invalid race type", PyString_AsString(value));
-    PyErr_Format(PyExc_TypeError, buf);
+  if(!isRace(race))
     return -1;
-  }
 
   CHAR_DATA *ch;
   PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
@@ -580,7 +594,6 @@
   PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
   // only move if we're not already here
   if(charGetRoom(ch) != room) {
-    char_from_room(ch);
     char_to_room(ch, room);
 
     // if we were on furniture, make sure we dismount it
@@ -620,10 +633,9 @@
   }
 }
 
-
 //
-// sends a newline-tagged message to the character
-PyObject *PyChar_send(PyChar *self, PyObject *value) {
+// sends text to the character
+PyObject *PyChar_send_raw(PyChar *self, PyObject *value) {
   char *mssg = NULL;
   if (!PyArg_ParseTuple(value, "s", &mssg)) {
     PyErr_Format(PyExc_TypeError, 
@@ -633,7 +645,7 @@
 
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch) {
-    send_to_char(ch, "%s\r\n", mssg);
+    send_to_char(ch, "%s", mssg);
     return Py_BuildValue("i", 1);
   }
   else {
@@ -644,6 +656,17 @@
   }
 }
 
+//
+// sends a newline-tagged message to the character
+PyObject *PyChar_send(PyChar *self, PyObject *value) {
+  PyObject *retval = PyChar_send_raw(self, value);
+  if(retval == NULL)
+    return NULL;
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  send_to_char(ch, "\r\n");
+  Py_DECREF(retval);
+  return Py_BuildValue("i", 1);
+}
 
 //
 // Send a newline-tagged message to everyone around the character
@@ -854,6 +877,25 @@
 }
 
 
+PyObject *PyChar_getbodypct(PyChar *self, PyObject *args) {
+  char   *parts = NULL;
+  CHAR_DATA *ch = NULL;
+
+  if (!PyArg_ParseTuple(args, "s", &parts)) {
+    PyErr_Format(PyExc_TypeError,"A comma-separated list of body parts needed");
+    return NULL;
+  }
+
+  ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to query body info for nonexistant character!");
+    return NULL;
+  }
+
+  return Py_BuildValue("d", bodyPartRatio(charGetBody(ch), parts));
+}
+
 //
 // equips a character with an item
 PyObject *PyChar_equip(PyChar *self, PyObject *args) {  
@@ -944,7 +986,7 @@
   
   obj = bodyGetEquipment(charGetBody(ch), pos);
   if(obj == NULL)
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   else
     return Py_BuildValue("O", objGetPyFormBorrowed(obj));
 }
@@ -1151,10 +1193,8 @@
   }
 
   PyObject *data = charGetAuxiliaryData(ch, keyword);
-  if(data == NULL) {
-    printf("Data is NULL for %s!!\r\n", keyword);
+  if(data == NULL)
     data = Py_None;
-  }
   PyObject *retval = Py_BuildValue("O", data);
   //  Py_DECREF(data);
   return retval;
@@ -1472,25 +1512,9 @@
   return retval;
 }
 
-PyObject *PyChar_all_sockets(PyObject *self) {
-  PyObject        *list = PyList_New(0);
-  LIST_ITERATOR *sock_i = newListIterator(socket_list);
-  SOCKET_DATA     *sock = NULL;
-  ITERATE_LIST(sock, sock_i) {
-    // only add sockets with attached characters who are in game
-    if(socketGetChar(sock) && charGetRoom(socketGetChar(sock)))
-      PyList_Append(list, charGetPyFormBorrowed(socketGetChar(sock)));
-  } deleteListIterator(sock_i);
-  PyObject *retval = Py_BuildValue("O", list);
-  Py_DECREF(list);
-  return retval;
-}
-
 PyMethodDef char_module_methods[] = {
   { "char_list", (PyCFunction)PyChar_all_chars, METH_NOARGS,
     "Return a python list containing an entry for every character in game." },
-  { "socket_list", (PyCFunction)PyChar_all_sockets, METH_NOARGS,
-    "Returns a list of all characters with attached sockets." },
   { "load_mob", PyChar_load_mob, METH_VARARGS,
     "load a mobile with the specified prototype to a room." },
   { "count_mobs", PyChar_count_mobs, METH_VARARGS,
@@ -1599,6 +1623,10 @@
 		      "'it' for neuters");
   PyChar_addGetSetter("user_groups", PyChar_getusergroups, NULL,
 		      "Returns the character's user groups");
+  PyChar_addGetSetter("socket", PyChar_getsocket, NULL,
+		      "Returns the character's socket if it exists.");
+  PyChar_addGetSetter("sock",   PyChar_getsocket, NULL,
+		      "Returns the character's socket if it exists.");
 
   // add in all of our methods for the Char class
   PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
@@ -1606,6 +1634,8 @@
   PyChar_addMethod("detach", PyChar_detach, METH_VARARGS,
 		   "detach an old script from the character.");
   PyChar_addMethod("send", PyChar_send, METH_VARARGS,
+		   "send a message to the character with appended newline.");
+  PyChar_addMethod("send_raw", PyChar_send_raw, METH_VARARGS,
 		   "send a message to the character.");
   PyChar_addMethod("sendaround", PyChar_sendaround, METH_VARARGS,
 		   "send a message to everyone around the character.");
@@ -1626,6 +1656,9 @@
 		   "from whatever it is currently in/on.");
   PyChar_addMethod("get_equip", PyChar_getequip, METH_VARARGS,
 		   "Returns the person's equipment in the specified slot.");
+  PyChar_addMethod("get_bodypct", PyChar_getbodypct, METH_VARARGS,
+		   "Returns the percent mass of the character's body taken up "
+		   "by the specified parts.");
   PyChar_addMethod("isActing", PyChar_is_acting, METH_VARARGS,
 		   "Returns True if the character is currently taking an "
 		   "action, and False otherwise.");
diff -ruN ../nakedmudv3.2.1/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv3.2.1/src/scripts/pyevent.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyevent.c	2006-12-24 22:15:56.000000000 -0500
@@ -35,7 +35,7 @@
   }
 
   // decrease the reference on our function and data
-  //  Py_DECREF(tuple);
+  Py_XDECREF(tuple);
 }
 
 
@@ -111,7 +111,9 @@
 //
 // start a new update (event that re-queues itself after completion)
 PyObject *PyEvent_start_update(PyObject *self, PyObject *args) {
-  return PyEvent_start(self, args, start_update);
+  PyErr_Format(PyExc_StandardError, "start_update is deprecated. Use start_event.");
+  return NULL;
+  /* return PyEvent_start(self, args, start_update); */
 }
 
 //
diff -ruN ../nakedmudv3.2.1/src/scripts/pyhooks.c src/scripts/pyhooks.c
--- ../nakedmudv3.2.1/src/scripts/pyhooks.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyhooks.c	2006-12-24 22:15:56.000000000 -0500
@@ -15,6 +15,7 @@
 #include "pychar.h"
 #include "pyobj.h"
 #include "pyexit.h"
+#include "pysocket.h"
 #include "pyplugs.h"
 #include "pyhooks.h"
 
@@ -98,6 +99,14 @@
       }
       bprintf(buf, "ex.%d", PyExit_AsUid(var));
     }
+    else if(!strcasecmp(token, "sk") || !strcasecmp(token, "sock")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PySocket_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Mudsock", i);
+	break;
+      }
+      bprintf(buf, "sk.%d", PySocket_AsUid(var));
+    }
     else if(!strcasecmp(token, "str")) {
       var = PyTuple_GetItem(vars, i);
       if(!PyString_Check(var)) {
@@ -162,36 +171,47 @@
   // id number we'll need for parsing some values
   int id = 0;
 
-  // we need to crash-proof this function still
-  //***********
-  // FINISH ME
-  //***********
-
   // go through all of our tokens
   ITERATE_LIST(token, token_i) {
     if(startswith(token, "ch")) {
       sscanf(token, "ch.%d", &id);
-      PyTuple_SetItem(list, i, charGetPyForm(propertyTableGet(mob_table,id)));
+      CHAR_DATA *ch = propertyTableGet(mob_table, id);
+      PyTuple_SetItem(list, i, (ch ? charGetPyForm(ch) : Py_None));
     }
     else if(startswith(token, "obj")) {
       sscanf(token, "obj.%d", &id);
-      PyTuple_SetItem(list, i, objGetPyForm(propertyTableGet(obj_table,id)));
+      OBJ_DATA *obj = propertyTableGet(obj_table, id);
+      PyTuple_SetItem(list, i, (obj ? objGetPyForm(obj) : Py_None));
     }
     else if(startswith(token, "rm")) {
       sscanf(token, "rm.%d", &id);
-      PyTuple_SetItem(list, i, roomGetPyForm(propertyTableGet(room_table,id)));
+      ROOM_DATA *rm = propertyTableGet(room_table, id);
+      PyTuple_SetItem(list, i, (rm ? roomGetPyForm(rm) : Py_None));
     }
     else if(startswith(token, "room")) {
       sscanf(token, "room.%d", &id);
-      PyTuple_SetItem(list, i, roomGetPyForm(propertyTableGet(room_table,id)));
+      ROOM_DATA *rm = propertyTableGet(room_table, id);
+      PyTuple_SetItem(list, i, (rm ? roomGetPyForm(rm) : Py_None));
     }
     else if(startswith(token, "ex")) {
       sscanf(token, "ex.%d", &id);
-      PyTuple_SetItem(list, i, newPyExit(propertyTableGet(exit_table, id)));
+      EXIT_DATA *ex = propertyTableGet(exit_table, id);
+      PyTuple_SetItem(list, i, (ex ? newPyExit(ex) : Py_None));
     }
     else if(startswith(token, "exit")) {
       sscanf(token, "exit.%d", &id);
-      PyTuple_SetItem(list,i, newPyExit(propertyTableGet(exit_table, id)));
+      EXIT_DATA *ex = propertyTableGet(exit_table, id);
+      PyTuple_SetItem(list, i, (ex ? newPyExit(ex) : Py_None));
+    }
+    else if(startswith(token, "sk")) {
+      sscanf(token, "sk.%d", &id);
+      SOCKET_DATA *sock = propertyTableGet(sock_table, id);
+      PyTuple_SetItem(list,i, (sock ? socketGetPyForm(sock) : Py_None));
+    }
+    else if(startswith(token, "sock")) {
+      sscanf(token, "sock.%d", &id);
+      SOCKET_DATA *sock = propertyTableGet(sock_table, id);
+      PyTuple_SetItem(list,i, (sock ? socketGetPyForm(sock) : Py_None));
     }
     else if(*token == HOOK_STR_MARKER) {
       char *str = strdup(token + 1);
diff -ruN ../nakedmudv3.2.1/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv3.2.1/src/scripts/pymud.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pymud.c	2006-12-24 22:15:56.000000000 -0500
@@ -20,6 +20,7 @@
 #include "../inform.h"
 #include "../handler.h"
 #include "../parse.h"
+#include "../races.h"
 
 #include "scripts.h"
 #include "pyroom.h"
@@ -27,6 +28,7 @@
 #include "pyobj.h"
 #include "pyplugs.h"
 #include "pyexit.h"
+#include "pysocket.h"
 
 
 
@@ -106,9 +108,10 @@
 // format a string to be into a typical description style
 PyObject *mud_format_string(PyObject *self, PyObject *args) {
   char *string = NULL;
+  bool indent  = TRUE;
 
   // parse all of the values
-  if (!PyArg_ParseTuple(args, "s", &string)) {
+  if (!PyArg_ParseTuple(args, "s|b", &string, &indent)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Can not format non-string values.");
     return NULL;
@@ -117,7 +120,7 @@
   // dup the string so we can work with it and not intrude on the PyString data
   BUFFER *buf = newBuffer(MAX_BUFFER);
   bufferCat(buf, string);
-  bufferFormat(buf, SCREEN_WIDTH, PARA_INDENT);
+  bufferFormat(buf, SCREEN_WIDTH, (indent ? PARA_INDENT : 0));
   PyObject *ret = Py_BuildValue("s", bufferString(buf));
   deleteBuffer(buf);
   return ret;
@@ -463,6 +466,28 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *mud_is_race(PyObject *self, PyObject *args) {
+  char       *race = NULL;
+  bool player_only = FALSE;
+  if(!PyArg_ParseTuple(args, "s|b", &race, &player_only)) {
+    PyErr_Format(PyExc_TypeError, "a string must be supplied");
+    return NULL;
+  }
+
+  if(player_only)
+    return Py_BuildValue("i", raceIsForPC(race));
+  else
+    return Py_BuildValue("i", isRace(race));
+}
+
+PyObject *mud_list_races(PyObject *self, PyObject *args) {
+  bool player_only = FALSE;
+  if(!PyArg_ParseTuple(args, "|b", &player_only)) {
+    PyErr_Format(PyExc_TypeError, "true/false value to list only player races must be provided.");
+    return NULL;
+  }
+  return Py_BuildValue("s", raceGetList(player_only));
+}
 
 
 //*****************************************************************************
@@ -515,6 +540,12 @@
 		  "adds a string to the mudlog");
   PyMud_addMethod("set_cmd_move", mud_set_cmd_move, METH_VARARGS,
 		  "sets the movement command");
+  PyMud_addMethod("is_race", mud_is_race, METH_VARARGS,
+		  "returns whether or not the string is a valid race.");
+  PyMud_addMethod("list_races", mud_list_races, METH_VARARGS,
+		  "returns a list of all the races available. Can take one "
+		  "argument that specifies whether or not to list player "
+		  "races.");
 
   Py_InitModule3("mud", makePyMethods(pymud_methods),
 		 "The mud module, for all MUD misc mud utils.");
